// $Id: timer_interrupt.c,v 1.1 2010/11/12 16:03:26 swaj Exp $

#include <stdio.h>
#include <mega164.h>
#include <delay.h>

#include "avr_types.h"
#include "config.h"
#include "global_vars.h"
#include "timer_interrupt.h"


// -----------------------------------------------------------------------------
static
void sleep_kbd(void)
{
	uint16_t cntr=0x30;
	while (--cntr) {}
}


// -----------------------------------------------------------------------------
uint8_t kbd_scan (void)
{
	switch (PINA & 0b00000111)
	{
	case 0b00000110:
		return KEY_1;

	case 0b00000101:
		return KEY_2;

	case 0b00000011:
		return KEY_3;

	case 0b00000001:
		return KEY_2_3;

	}


	return KEY_NOKEY;
}


// -----------------------------------------------------------------------------
void keyboard (void)
{
	uint8_t scan;
	uint8_t rpts;


	if ( kbd_inactiv_timer >0) {
		kbd_inactiv_timer--;
		return;
	}

	scan = kbd_scan();


	if (scan == KEY_NOKEY)
	{
		last_keyscan_repeat= 0;
		last_keyscan=KEY_NOKEY;
		//last_key=KEY_NOKEY;
	}
	else
	{
		if (last_keyscan != scan) { // new pressed, remember and reset repeat
			last_keyscan = scan;
			last_keyscan_repeat= 0;
			return;
		}
		else { // still pressed
			if (last_keyscan == KEY_1) // bigger delay
				rpts = keyboard_repeats_set;
			else
				rpts = KEYBOARD_REPEATS;

			if (last_keyscan_repeat++ < rpts) {
				return;
			}
			else {
				last_keyscan_repeat = KEYBOARD_REPEATS;
				last_key = last_keyscan;
				if (last_key == KEY_1)
					kbd_inactiv_timer = KEYBOARD_INACTIVITY_SET;
				else
					kbd_inactiv_timer = KEYBOARD_INACTIVITY;
				return;
			}
		}
	}
}

// -------------- Timer 0 input 3600Hz , /72 -> 50Hz ---------------
void timer_interrupt (void)
{
	uint8_t i;

	/* here 50Hz */

	keyboard();

	if (++timer0_cntr < TIMER0_INTR_RATE )
		return;

	timer0_cntr = 0;

	for (i=0; i<  TIMERS_MAX; i++)
		if (timers[i])
			timers[i]--;
}


/* __END__ */
